#include <stdlib.mqh>
//+------------------------------------------------------------------+
//|                                                    EMA_CROSS.mq4 |
//|                                                      Coders Guru |
//|                                         http://www.forex-tsd.com |
//|                                         modified by Graham Kozlyk|
//|                                                gkozlyk@gmail.com |
//|                many thanx to those that developed the Hans123 EA |
//|     plus the donchian scalper.  Gave me ideas and saved me time. |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| TODO: Add Money Management routine                               |
//+------------------------------------------------------------------+

#property copyright "Coders Guru"
#property link      "http://www.forex-tsd.com"

//---- input parameters
extern double    TakeProfit=10; //110-130
extern double    Lots=1.0;  //1   I set this to 1.05 so i know it is from a 5 min chart (hence the .05)
extern double    TrailingStop=40;   //20
extern double    StopLoss=25;  //50
extern bool      UseStopLoss = true;

extern int ShortEma = 10;
extern int LongEma = 80;
extern bool      immediate_trade = true;
extern bool      reverse_immediate = true;  //this switch is if you want to go pro or counter trend if your trade starts between crosses
int Reverse1, Reverse2;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
  
bool isNewSumbol(string current_symbol)
  {
   //loop through all the opened order and compare the symbols
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol)
      return (False);
    }
    return (True);
}

int Crossed (double line1 , double line2)
      //line 1 is Fast EMA and line 2 is Long or Slow EMA  
   {
      static int last_direction = 0;
      static int current_direction = 0;
      
      //Don't work in the first load, wait for the first cross!
      static bool first_time = true;
      if(first_time == true)
      {
         first_time = false;
         return (0);
      }
      if(reverse_immediate==true)  //this is the part where it sets reversed trades outside of crosses
      {
         Reverse1 = 2;
         Reverse2 = 1;
      }
      if(reverse_immediate==false) //this is protrend trades outside of crosses
      {
         Reverse1 = 1;
         Reverse2 = 2;
      }
      
      if(line1>line2)current_direction = 1; //up  set for 1
      if(line1<line2)current_direction = 2; //down  set for 2
 
      if(immediate_trade==false)  //this section for taking trades immediately
      {
         if(last_direction == 0) //first use
         {
                  last_direction = current_direction;
                  return(0); }
         
      }
      if(immediate_trade==true)
      {
         if(last_direction == 0) //first use
         {
                  if(line1>line2)current_direction = Reverse1; //up      1 is a buy trade
                  if(line1<line2)current_direction = Reverse2; //down    2 is a sell trade
                  return(current_direction); }   
      }
      
        
      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            return (last_direction);
      }
      else
      {
            return (0); //not changed
      }
   }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {

// customizable variables   these ones are for 5 min charts and overwrite external variables.  A thought here is to do offset off of the external variables inputed above (eg. Limit = Limit +5)

if (Symbol()=="GBPUSD") 
   {
      TrailingStop = 40;
      TakeProfit = 13;
      StopLoss=25;
      Lots=2.0;
      UseStopLoss = true;
      reverse_immediate = true;
   } 
    
    else    if (Symbol()=="EURUSD") 
    {
      TrailingStop = 40;
      TakeProfit = 10;
      StopLoss=25;
      Lots=1.3;
      UseStopLoss = true;
      immediate_trade = true;
      reverse_immediate = true;    } 
    
    else    if (Symbol()=="USDCHF") 
    {
      TrailingStop = 40;
      TakeProfit = 11;
      StopLoss=25;
      Lots=1.1;
      UseStopLoss = true;
      immediate_trade = true;
      reverse_immediate = true;    } 

    else    if (Symbol()=="USDCAD") 
    {
      TrailingStop = 40;
      TakeProfit = 11;
      StopLoss=25;
      Lots=1.0;
      UseStopLoss = true;
      immediate_trade = true;
      reverse_immediate = true;    } 
    else    if (Symbol()=="USDJPY") 
    {
      TrailingStop = 40;
      TakeProfit = 12;
      StopLoss=25;
      Lots=1.4;
      UseStopLoss = true;
      immediate_trade = true;
      reverse_immediate = true;    } 
    else    if (Symbol()=="GBPJPY") 
    {
      TrailingStop = 40;
      TakeProfit = 25;
      StopLoss=35;
      Lots=0.7;
      UseStopLoss = true;
      immediate_trade = true;
      reverse_immediate = true;    } 
    else    if (Symbol()=="EURJPY") 
    {
      TrailingStop = 40;
      TakeProfit = 20;
      StopLoss=30;
      Lots=0.7;
      UseStopLoss = true;
      immediate_trade = true;
      reverse_immediate = true;    } 





   int cnt, ticket, total;
   double SEma, LEma;
   int MagicNumber;
   
   MagicNumber = func_Symbol2Val(Symbol())*10000 + func_TimeFrame_Const2Val(Period());  // each pair has an automatically generated magic number
   
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }
     
     
   SEma = iMA(NULL,0,ShortEma,0,MODE_EMA,PRICE_CLOSE,0);
   LEma = iMA(NULL,0,LongEma,0,MODE_EMA,PRICE_CLOSE,0);
   
   /*if (!IsTesting()) {    //i included this in so that i can see settings realtime as the EA is running
      Comment(" v 2.0 ",
               "\n",
               "\n","                  FastEMA = ",SEma,
               "\n","                  SlowEMA = ",LEma,
               "\n",
               );
   }
*/
   static int isCrossed  = 0;
   isCrossed = Crossed (SEma,LEma);
   
   total  = OrdersTotal();
  
   if(total < 1 || isNewSumbol(Symbol())) 
     {
       if(isCrossed == 1 )
         {
            
            if(UseStopLoss)
               ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"EMA_CROSS_2",MagicNumber,0,Green);
            else
               ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"EMA_CROSS_2",MagicNumber,0,Green);
            
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
              }
            else Print("Error opening BUY order : ",GetLastError()); 
            return(0);
         }
         if(isCrossed == 2)
         {
            if(UseStopLoss)
               ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"EMA_CROSS_2",MagicNumber,0,Red);
            else
               ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"EMA_CROSS_2",MagicNumber,0,Red);
            
            if(ticket>0)
              {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
              }
            else Print("Error opening SELL order : ",GetLastError()); 
            return(0);
         }
         return(0);
     }
     
     
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      //OrderPrint();
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }


//+------------------------------------------------------------------+
//| these are used for magic numbers                                 |
//+------------------------------------------------------------------+


int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1: 
         return(1);
      case 5:  
         return(5);
      case 15:
         return(15);
      case 30:
         return(30);
      case 60:
         return(60);
      case 240:
         return(240);
      case 1440:
         return(1440);
      case 10080:
         return(10080);
      case 43200:
         return(43200);
   }
}

int func_Symbol2Val(string symbol) {
	if(symbol=="EURUSD") {
		return(1);
	} else if(symbol=="GBPUSD") { return(2);
	} else if(symbol=="USDCHF") { return(3);
	} else if(symbol=="USDJPY") {	return(4);
	} else if(symbol=="USDCAD") {	return(5);
	} else if(symbol=="AUDUSD") {	return(6);
	} else if(symbol=="EURJPY") {	return(7);
	} else if(symbol=="GBPJPY") {	return(8);
	} else if(symbol=="EURGBP") {	return(9);
	} else {
		//Comment("unexpected Symbol");
		return(0);
	}
}
  
//+------------------------------------------------------------------+